#include "widget.h"
#include "ui_widget.h"
#include <QHostAddress>

Widget::Widget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::Widget)
{
    ui->setupUi(this);
    // connexion des signaux du client à des slots locaux
    connect(&client, SIGNAL(connected()), this, SLOT(connected()));
    connect(&client, SIGNAL(readyRead()), this, SLOT(dataIncomming()));
    connect(&client, SIGNAL(disconnected()), this, SLOT(disconnected()));
    ui->groupBox->setEnabled(false);
}

//________________________________________________________________________
Widget::~Widget()
{
    delete ui;
}

//____________ appui sur le bouton connexion ______________________________
void Widget::on_pushButtonConnexion_clicked()
{
    if (!client.isOpen())
        client.connectToHost(QHostAddress(ui->lineEditServerIP->text()), ui->spinBox->value());
    else client.close();
}

//_____________ appui sur le bouton envoyer des données ___________________
void Widget::on_pushButtonEnvoyer_clicked()
{
    QString data = ui->lineEditEnvoi->text()+"\r\n";
    client.write(data.toUtf8().constData(), data.size());
}

//_____________ le client est connecté _____________________________________
void Widget::connected(){
    ui->groupBox->setEnabled(true);
    ui->pushButtonConnexion->setText("Déconnexion");
}

//_____________ des données sont arrivées sur le client _____________________
void Widget::dataIncomming(){
    if (client.canReadLine()){
        QByteArray data = client.readAll();
        ui->textEdit->append(data);
    }
}

//____________ le client s'est déconnecté ____________________________________
void Widget::disconnected(){
    ui->groupBox->setEnabled(false);
    ui->pushButtonConnexion->setText("Connexion");
}
